<!DOCTYPE html>
<html>
<head>
	<meta charset="utf-8">
	<meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">

	<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.0/dist/css/bootstrap.min.css" integrity="sha384-B0vP5xmATw1+K9KRQjQERJvTumQW0nPEzvF6L/Z6nronJ3oUOFUFpCjEUQouq2+l" crossorigin="anonymous"/>
	<title>Bootstrap - Flex</title>
</head>
<body>

	<div class="text-center">
		<h1>Bootstrap Flex</h1>
		<p>Use d-flex class to create a flex container and tranform direct children into flex items</p>

		<!-- d-flex -->
		<!-- we use d-flex to easily align our elements vertically (column) or horizontally (row)-->

		<h2>Centering Elements</h2>

		<h3>Centering flex-column without align-items-center</h3>
		<div style="height: 500px" class="bg-secondary p-3 justify-content-center d-flex flex-column">
			<div class="h-25 p-3 bg-success">Flex Item A</div>
			<div class="h-25 p-3 bg-warning">Flex Item B</div>
			<div class="h-25 p-3 bg-danger">Flex Item A</div>
		</div>

		<h3>Centering flex-column with align-items-center</h3>
		<div style="height: 500px" class="bg-secondary p-3 justify-content-center align-items-center d-flex flex-column">
			<div class="h-25 p-3 bg-success">Flex Item A</div>
			<div class="h-25 p-3 bg-warning">Flex Item B</div>
			<div class="h-25 p-3 bg-danger">Flex Item A</div>
		</div>

		<h2>Flex Row</h2>
		<!-- we use flex-row for horizintal alignment -->
		<div class="bg-dark p-3 d-flex flex-row">
			<div class="p-3 bg-success">Flex Item A</div>
			<div class="p-3 bg-warning">Flex Item B</div>
			<div class="p-3 bg-danger">Flex Item C</div>
		</div>

		<h2>Flex Row Center</h2>
		<div class="bg-dark p-3 d-flex flex-row justify-content-center">
			<div class="p-3 bg-success">Flex Item A</div>
			<div class="p-3 bg-warning">Flex Item B</div>
			<div class="p-3 bg-danger">Flex Item C</div>
		</div>

		<h2>Flex Row Reverse</h2>
		<div class="bg-dark p-3 d-flex flex-row-reverse">
			<div class="p-3 bg-success">Flex Item A</div>
			<div class="p-3 bg-warning">Flex Item B</div>
			<div class="p-3 bg-danger">Flex Item C</div>
		</div>

		<h2>Creating Space Between Elements</h2>
		<!-- by default when we are using d-flex our elements aligment are based in flex-row -->
		<div class="bg-dark p-3 d-flex justify-content-around">
			<div class="p-3 bg-success col-md-2">Flex Item A</div>
			<div class="p-3 bg-warning col-md-2">Flex Item B</div>
			<div class="p-3 bg-danger col-md-2">Flex Item C</div>
		</div>

		<h2>Flexbox With Margin</h2>
		<div class="bg-dark p-3 d-flex">
			<div class="p-3 bg-success mr-auto">Logo</div>
			<div class="p-3 bg-warning">Flex Item B</div>
			<div class="p-3 bg-danger">Flex Item C</div>
			<div class="p-3 bg-primary">Flex Item D</div>
		</div>

		<h2>Nested Flex Elements</h2>
		<!-- when we don't declare/include any screen size, by default it works like sm -->
		<!-- sm = small upto the next sizes -->
		<!-- md = medium upto the next sizes -->
		<!-- lg = large upto the next sizes -->
		<div class="bg-dark p-3 d-sm-block d-md-flex" >
			<div class="p-3 bg-success mr-auto">Flex Item A</div>
			<div class="w-50 d-sm-block d-md-flex justify-content-between">
				<div class="p-3 bg-warning">Flex Item B.1</div>
				<div class="p-3 bg-danger">Flex Item B.2</div>
				<div class="p-3 bg-primary">Flex Item B.3</div>
			</div>
		</div>
	</div>

      </div>

     <!-- Mini Activity 1 -->
     <!-- <div class="mt-5 mb-5 d-md-flex justify-content-around ml-3 mr-3 "> -->
	<div class="mt-5 mb-5 d-sm-block d-md-flex justify-content-around ml-3 mr-3 ">

		<!-- Sir John Marcelli's solution -->
	<!-- <div class="mt-5 mb-5 d-sm-block  d-md-flex flex-sm-row justify-content-around ml-3 mr-3 "> -->

		<!-- The elements should be aligned horizontally if the device size is medium or large -->
		<!-- While in small devices it should be aligned vertically -->
		<div class="col-md-4 text-center ">
			<img class="img-fluid" src="images/blue.png">
			<div>I'm a blue photo</div>
		</div> 

		<div class="col-md-4 text-center">
			<img class="img-fluid" src="images/red.png">
			<div>I'm a red photo</div>
		</div> 

		<div class="col-md-4 text-center">
			<img class="img-fluid" src="images/green.png">
			<div>I'm a green photo</div>
		</div> 

	</div>

	<!-- Mini Activity 2 -->
	<!-- 1.A Align all blue horizontally if medium to large devices -->
	<!-- 1.B Align all green horizontally if medium to large devices -->
	<!-- 1.A Align all blue vertically if medium to large devices -->
	<!-- 1.B Align all green vertically if medium to large devices -->

	<div class="mb-4">
			<!-- <div class="container-fluid d-flex flex-md-column text-center"> -->
			<!-- row = horizantally aligned -->
			<!-- column = vertically aligned -->
      <div class="container-fluid d-flex flex-sm-row flex-md-column  text-center">
      
          <div class="align-items-center justify-content-center">
          		<!-- all of these elements will be vertically aligned if in small device-->
              <img width="150" class="mr-3 mb-3 " src="images/blue.png"/>
              <img width="150" class="mr-3 mb-3 " src="images/blue.png"/>
              <img width="150" class="mr-3 mb-3 " src="images/blue.png"/>
              <img width="150" class="mr-3 mb-3 " src="images/blue.png"/>
          </div>

          <div class="align-items-center justify-content-center">
          	<!-- all of these elements will be vertically aligned if in small device-->
              <img width="150" class="mr-3 mb-3 " src="images/green.png"/>
              <img width="150" class="mr-3 mb-3 " src="images/green.png"/>
              <img width="150" class="mr-3 mb-3 " src="images/green.png"/>
              <img width="150" class="mr-3 mb-3 " src="images/green.png"/>
          </div>

      </div>
		





	<script src="https://cdn.jsdelivr.net/npm/jquery@3.5.1/dist/jquery.slim.min.js" integrity="sha384-DfXdz2htPH0lsSSs5nCTpuj/zy4C+OGpamoFVy38MVBnE+IbbVYUew+OrCXaRkfj" crossorigin="anonymous"></script>
	<script src="https://cdn.jsdelivr.net/npm/bootstrap@4.6.1/dist/js/bootstrap.bundle.min.js" integrity="sha384-fQybjgWLrvvRgtW6bFlB7jaZrFsaBXjsOMm/tB9LTS58ONXgqbR9W8oWht/amnpF" crossorigin="anonymous"></script>

</body>
</html>
